
#if !defined(TEMPLATE_H_INCLUDED)
#define TEMPLATE_H_INCLUDED

template<class T>
class CArray {
public:
  CArray();
  CArray(int count);
  CArray(const CArray &source);
  ~CArray();
  CArray& operator=(const CArray &source);
  void Init(int count);
  void Destroy();
  int Count() { return count; }
  T& operator[](int i);
private:
  T *array;
  int count;
};

template <class T>
CArray<T>::CArray() {
  array = NULL;
  count = 0;
}

template <class T>
CArray<T>::CArray(int count) {
  array = NULL;
  Init(count);
}

template <class T>
CArray<T>::CArray(const CArray<T> &source) {
  array = NULL;
  operator=(source);
}

template <class T>
CArray<T>::~CArray() {
  Destroy();
}

template <class T>
CArray<T>& CArray<T>::operator=(const CArray<T> &source) {
  Init(source.count);
  if (source.array) {
    for (int i=0; i<count; i++) array[i] = source.array[i];
  }
  return *this;
}

template <class T>
void CArray<T>::Init(int count) {
  Destroy();
  this->count = count;
  if (count) array = new T[count];
}

template <class T>
void CArray<T>::Destroy() {
  if (!array) return;
  for (int i=0; i<count; i++) array[i].~T();
  delete array;
  array = NULL;
}

template <class T>
T& CArray<T>::operator[](int i) {
  if (i>=count) throw "index out of bounds"; // !!!!!!!!!!
  return array[i];
}

#endif
